function check(partId, webSubmit)
%SUBMIT Submit your code and output to the ml-class servers
%   SUBMIT() will connect to the ml-class server and submit your solution
  fprintf('==\n== [ml-class] Submitting Solutions | Programming Exercise %s\n==\n', ...
          homework_id());
  if ~exist('partId', 'var') || isempty(partId)
    partId = promptPart();
  end

  if ~exist('webSubmit', 'var') || isempty(webSubmit)
    webSubmit = 0; % submit directly by default 
  end

  % Check valid partId
  partNames = validParts();
  if ~isValidPartId(partId)
    fprintf('!! Invalid homework part selected.\n');
    fprintf('!! Expected an integer from 1 to %d.\n', numel(partNames) + 1);
    fprintf('!! Submission Cancelled\n');
    return
  end

  % Setup submit list
  if partId == numel(partNames) + 1
    submitParts = 1:numel(partNames);
  else
    submitParts = [partId];
  end

  for s = 1:numel(submitParts)
    thisPartId = submitParts(s);
    [result your_answer correct_answer] = check_single(thisPartId);
    if result == true
      printf("Dobrze!\n");
    else
      printf("Zle...Powinno byc:\n");
      correct_answer
      printf("A nie: \n");
      your_answer
    end
  end
end

% ================== CONFIGURABLES FOR EACH HOMEWORK ==================

function id = homework_id() 
  id = '6';
end

function [partNames] = validParts()
  partNames = { 'Gaussian Kernel', ...
                'Parameters (C, sigma) for Dataset 3', ...
                'Email Preprocessing' ...
                'Email Feature Extraction' ...
                };
end

function srcs = sources()
  % Separated by part
  srcs = { { 'gaussianKernel.m' }, ...
           { 'dataset3Params.m' }, ...
           { 'processEmail.m' }, ...
           { 'emailFeatures.m' } };
end

function [correct out coransw] = check_single(partId)
  load 'results.mat'
  load('ex6data3.mat');
EPSILON_ERROR = 10^-5;
  % Random Test Cases
  x1 = sin(1:10)';
  x2 = cos(1:10)';
  ec = 'the quick brown fox jumped over the lazy dog';
  wi = 1 + abs(round(x1 * 1863));
  wi = [wi ; wi];

  if partId == 1
    out =  gaussianKernel(x1, x2, 2);
    coransw = out1;
    if abs(out1 - out) < EPSILON_ERROR
      correct = true;
    else
      correct = false;
    end
  elseif partId == 2
   [outa outb] =  dataset3Params(X, y, Xval, yval);
    coransw = {out2a out2b};
    out = {outa outb};
    if abs(out2a - outa) < EPSILON_ERROR && abs(out2b - outb) < EPSILON_ERROR
      correct = true;
    else
      correct = false;
    end
  elseif partId == 3
    out = processEmail(ec);
    coransw = out3;
    if abs(out3 - out) < EPSILON_ERROR
      correct = true;
    else
      correct = false;
    end
  elseif partId == 4
    out = emailFeatures(wi);
    coransw = out4;
    if abs(out4 - out) < EPSILON_ERROR
      correct = true;
    else
      correct = false;
    end
  end 

end


function partId = promptPart()
  fprintf('== Select which part(s) to submit:\n');
  partNames = validParts();
  srcFiles = sources();
  for i = 1:numel(partNames)
    fprintf('==   %d) %s [', i, partNames{i});
    fprintf(' %s ', srcFiles{i}{:});
    fprintf(']\n');
  end
  fprintf('==   %d) All of the above \n==\nEnter your choice [1-%d]: ', ...
          numel(partNames) + 1, numel(partNames) + 1);
  selPart = input('', 's');
  partId = str2num(selPart);
  if ~isValidPartId(partId)
    partId = -1;
  end
end

function ret = isValidPartId(partId)
  partNames = validParts();
  ret = (~isempty(partId)) && (partId >= 1) && (partId <= numel(partNames) + 1);
end

